;AGREGADO MAR2014
;pro main, path
pro main

;AGREGADO FEB2014 para que ande directamente desde IDL
envi_batch_init

;AGREGADO MAY2014 Inicializamos el bloque comun de projecciones y elipsoides
@map_proj_init_commonblock

;AGREGADO MAR2014
setenv,'paramFile=input_param.txt'


	;paramFile = path + 'input_param.txt'
	paramFile = 'input_param.txt'

	;AGREGADO FEB2014
	readSilentFile, paramFile, 'paths', 'path_img', path_img

	;-------------------
	;INGRESO DE IMAGENES
	;-------------------
	;ingreso del DEM e imgenes derivadas
	readSilentFile, paramFile, 'paths', 'fileDEM', fileDEM

	;AGREGADO FEB2014 para eliminar '_dem' del nombre de la imagen
	;nombre_img=FILE_BASENAME(fileDEM,'_dem')
	nombre_img=FILE_BASENAME(fileDEM)

	;-------------------------------------------------------------------
	;AGREGADO FEB2014 para calcular slope y shaded imgs con calcENVIprod

	fInfo = FILE_INFO(path_img + nombre_img + '_slope')
	;solo entra al if y genera el archivo si no existe el archivo previamente (para que calcule solo una vez)
	if (fInfo.exists eq 0) then begin
		calcENVIProd, path_img + nombre_img, fileDEM, /SLOPE
	endif
	fileSLOPE = fInfo.name

	fInfo = FILE_INFO(path_img + nombre_img + '_shaded_relief')
	;solo entra al if y genera el archivo si no existe el archivo previamente (para que calcule solo una vez)
	if (fInfo.exists eq 0) then begin
		calcENVIProd, path_img + nombre_img, fileDEM, /SHRELIEF
	endif
	fileHILLSHADE = finfo.name
	;-------------------------------------------------------------------

	;con los cambios de arriba esto ya no va
	;readSilentFile, paramFile, 'paths', 'fileSLOPE', fileSLOPE
	;readSilentFile, paramFile, 'paths', 'fileHILLSHADE', fileHILLSHADE	;solo usado para visualizacin
   	;-------------------

	;AGREGADO MARZO2014
	;----------------------------------------------------
	;INGRESO DE DIMENSIONES DEL PIXEL Y DATOS GEOGRAFICOS
	;----------------------------------------------------
	readdata,fileDEM,dem,dims=dims,nl=nl,mapinfo=mapinfo

	;dimensiones del pixel del DEM
	px_dimx=mapinfo.ps[0]
	px_dimy=mapinfo.ps[1]

	;tipo de; DEM (INT=2; FLOAT=4)
	dem_type=SIZE(dem,/TYPE)

	;proyeccion del DEM
	dem_projection=mapinfo.proj.name
	dem_datum=mapinfo.proj.datum
	dem_zone=mapinfo.proj.params[0]

	;AGREGADO MAY2014: CONTROL si projection y datum son soportados o no
	flagProjection=testProjection(dem_projection)
	flagDatum=testEllipsoid(dem_datum)

	;if porque MAP_PROJ_INIT no reconoce 'WGS-84' y si reconoce 'WGS 84'
	;if dem_datum eq 'WGS-84' then dem_datum='WGS 84'
	dem_projection=STRJOIN(STRSPLIT(dem_projection,'-',/EXTRACT),' ')
	dem_datum=STRJOIN(STRSPLIT(dem_datum,'-',/EXTRACT),' ')

	;AGREGADO MAY2014: se calcula coord_utm solo si la projection es soportada
	; y si Datum no es soportado se lo cambia a WGS 84
	if (flagProjection eq 1) then coord_utm='ERROR'

	if (flagProjection eq 0) then begin
		if (flagDatum eq 1) then dem_datum='WGS 84'
		;if para opcion de usar proyeccion sin Zone
		if dem_projection eq 'UTM' then $
			 coord_utm=MAP_PROJ_INIT(dem_projection,DATUM=dem_datum,ZONE=dem_zone) $
		else coord_utm=MAP_PROJ_INIT(dem_projection,DATUM=dem_datum)
	endif

	;coordenadas de la esquina superior izquierda del DEM
	coord_utm_x=mapinfo.mc[2]
	coord_utm_y=mapinfo.mc[3]

	;----------------------------------------------------

;	;ELIMINADO MARZO2014
;	;ingreso de las dimensiones (en metros) del pixel del DEM
;	readSilentFile, paramFile, 'general', 'px_dimx', valorx
;	readSilentFile, paramFile, 'general', 'px_dimy', valory
;	readSilentFile, paramFile, 'general', 'px_type', px_type
;	readSilentFile, paramFile, 'general', 'dem_type', dem_type
;	;-------------------------------------------
;	;OPCION DIMENSIONES DE PIXEL INTEGER O FLOAT
;	if (px_type eq 'INT') then begin
;		px_dimx=FIX(valorx)
;		px_dimy=FIX(valory)
;	endif
;	if (px_type eq 'FLOAT') then begin
;		px_dimx=FLOAT(valorx)
;		px_dimy=FLOAT(valory)
;	endif
;	;-------------------------------------------
;	;ingreso de sistema de coordenadas del DEM
;	readSilentFile, paramFile, 'geographic', 'projection', valor1
;	readSilentFile, paramFile, 'geographic', 'datum', valor2
;	readSilentFile, paramFile, 'geographic', 'zone', valor3
;	;if para opcion de usar proyeccion sin Zone
;	if valor3 eq 'NO' then $
;		 coord_utm=MAP_PROJ_INIT(FIX(valor1),DATUM=FIX(valor2)) $
;	else coord_utm=MAP_PROJ_INIT(FIX(valor1),DATUM=FIX(valor2),ZONE=FIX(valor3))
;	;------------------------------------------------------------
;	;ingreso coordenadas de la esquina superior izquierda del DEM
;	readSilentFile, paramFile, 'geographic', 'coord_utm_x', valorx
;	readSilentFile, paramFile, 'geographic', 'coord_utm_y', valory
;	coord_utm_x=DOUBLE(valorx)
;	coord_utm_y=DOUBLE(valory)
;	;----------------------------------------------------

	;---------------------
	;OPCION CRATER/CALDERA (definir si hay o no crater/caldera)
	;---------------------
	readSilentFile, paramFile, 'crater', 'crater?', valor_crater
	;---------------------

	;--------------------
	;INGRESO DE CONTORNOS
	;--------------------
	;ingreso del path donde estn los contornos ROIs de los edificios volcs
	readSilentFile, paramFile, 'paths', 'dirROI', dirRoi
	;seleccin de contornos ROIs a ser analizados
	selRoiFiles, dirRoi, '*'+'edif.roi', listaRoi
	;--------------------

;IF de precaucin...
if (listaRoi[0] ne '') then begin

	;--------------------
	;APERTURA DE IMAGENES
	;--------------------
	envi_open_data_file,fileDEM,r_fid=fid_dem
	envi_file_query, fid_dem, ns=ns, nl=nl

	envi_open_data_file,fileSLOPE,r_fid=fid_slope
	;AGREGADO FEB2014 porque cuando corre calcENVIprod mas arriba el fid_slope tiene dos numeros
	fid_slope=fid_slope[0]
	envi_file_query, fid_slope

	envi_open_data_file,fileHILLSHADE,r_fid=fid_hillshade
	;AGREGADO FEB2014 porque cuando corre calcENVIprod mas arriba el fid_hillshade tiene dos numeros
	fid_hillshade=fid_hillshade[0]
	envi_file_query, fid_hillshade
	;--------------------

	;--------------------------------------
	;IMAGENES COMPLETAS SE ASIGNAN A ARRAYS
	;--------------------------------------
	;(sirve para que no haya ceros alrededor del contorno y si se quiere cortar el dem mas all del contorno, para visualizacin)
	;--------------------------
	;OPCION DEM INTEGER O FLOAT
	if (dem_type eq 2) then begin
		DEM_EXTERNO=intarr(ns,nl)
	endif
	if (dem_type eq 4) then begin
		DEM_EXTERNO=fltarr(ns,nl)
	endif
	openr,1,fileDEM
	readu,1,DEM_EXTERNO
	close,1

	SLOPE_EXTERNO=fltarr(ns,nl)
	openr,1,fileSLOPE
	readu,1,SLOPE_EXTERNO
	close,1

	HILLSHADE_EXTERNO=fltarr(ns,nl)
	openr,1,fileHILLSHADE
	readu,1,HILLSHADE_EXTERNO
	close,1
	;--------------------------------------

	;------------------------------------
	;LOOP PARA CADA EDIFICIO SELECCIONADO
	;------------------------------------
	FOR i=0L, N_ELEMENTS(listaRoi)-1 do begin

		;para eliminar 'edif.roi' del nombre del volcn
		nombre_volc=FILE_BASENAME(listaRoi[i],'edif.roi')

		envi_restore_rois,dirRoi + '/' + listaRoi[i]
		roi_id=envi_get_roi_ids(fid=fid_dem)
		nRoi=envi_get_roi(roi_id[0])
		y=nRoi/ns															;es la posicon en coord y de los puntos del roi
		x=nRoi-y*ns															;es la posicon en coord x de los puntos del roi
		data_dem=envi_get_roi_data(roi_id[0],fid=fid_dem,pos=0)				;data_dem contiene los valores de elevacion del dem de la zona que abarca el roi
		data_slope=envi_get_roi_data(roi_id[0],fid=fid_slope,pos=0) 		;data_slope contiene los valores de pendiente de la zona que abarca el roi
		data_hillshade=envi_get_roi_data(roi_id[0],fid=fid_hillshade,pos=0) ;data_hillshade contiene los valores de hillshade de la zona que abarca el roi
		envi_delete_rois, roi_id

		;clculo de valores min y max de las coord x-y del contorno[i] dentro del DEM
		x_min=MIN(x)
		x_max=MAX(x)
		y_min=MIN(y)
		y_max=MAX(y)

		;clculo de el num de columnas y filas que abarcan el contorno[i]
		col=x_max-x_min+1
		row=y_max-y_min+1

		;construccion del DEM del edificio; dem va a tener zeros alrededor del contorno[i]
		;--------------------------
		;OPCION DEM INTEGER O FLOAT
		if (dem_type eq 2) then begin
			xyz=intarr(3,N_ELEMENTS(data_dem))
			dem=intarr(col,row)
			dem_tot=intarr(col,row)
		endif
		if (dem_type eq 4) then begin
			xyz=fltarr(3,N_ELEMENTS(data_dem))
			dem=fltarr(col,row)
			dem_tot=fltarr(col,row)
		endif
		;---------------------------
		xyz[0,*]=x-x_min
		xyz[1,*]=y-y_min
		xyz[2,*]=data_dem

		;-------------------------------------------------------------------
		;AGREGADO MAYO 2010 para volcs con alturas negativas (eg en Etiopia)
		 dem[*,*]=-9999
		;-------------------------------------------------------------------
		for k=0L,N_ELEMENTS(data_dem)-1 do begin
			dem[xyz[0,k],xyz[1,k]]=xyz[2,k]
		endfor

		;recorte del DEM externo a un dem_tot que abarque el edificio (sin zeros fuera del contorno)
		dem_tot=DEM_EXTERNO[x_min:x_max,y_min:y_max]

		;construccion del SLOPE del edificio
		ijk=fltarr(3,N_ELEMENTS(data_slope))
		ijk[0,*]=x-x_min
		ijk[1,*]=y-y_min
		ijk[2,*]=data_slope
		slope=fltarr(col,row)
		for k=0L,N_ELEMENTS(data_slope)-1 do begin
			slope[ijk[0,k],ijk[1,k]]=ijk[2,k]
		endfor
		;recorte del SLOPE externo a un slope_tot que abarque el edificio (sin zeros fuera del contorno)
		slope_tot=fltarr(col,row)
		slope_tot=SLOPE_EXTERNO[x_min:x_max,y_min:y_max]

		;construccion del HILLSHADE del edificio
		ijk=fltarr(3,N_ELEMENTS(data_hillshade))
		ijk[0,*]=x-x_min
		ijk[1,*]=y-y_min
		ijk[2,*]=data_hillshade
		hillshade=fltarr(col,row)
		for k=0L,N_ELEMENTS(data_hillshade)-1 do begin
			hillshade[ijk[0,k],ijk[1,k]]=ijk[2,k]
		endfor
		;recorte del HILLSHADE externo a un hillshade_tot que abarque el edificio (sin zeros fuera del contorno)
		hillshade_tot=fltarr(col,row)
		hillshade_tot=HILLSHADE_EXTERNO[x_min:x_max,y_min:y_max]

		;calculo de coordenadas UTM esquina superior izquierda del DEM del edificio
		x_start_utm=coord_utm_x+(px_dimx*x_min)
		y_start_utm=coord_utm_y-(px_dimy*y_min)
		;------------------------------------

	;----------------------
	;SECCION CRATER/CALDERA
	;----------------------
	;se definen las variables de salida por si no hay crater/caldera y no se entra en el loop
	crater_dem=-22
	crater_slope=-22
	crater_dembig=-22
	cratermask=-22
	cratermask_difx=-22
	cratermask_dify=-22

	if (STRING(valor_crater) eq 'YES') then begin

		;ingreso del ROI del crater/caldera y de los datos del DEM y SLOPE dentro del ROI
		envi_restore_rois,dirRoi + '/' + nombre_volc + 'crater' + '.roi'


		roi_id=envi_get_roi_ids(fid=fid_dem)
		nRoi=envi_get_roi(roi_id[0])
		crater_y=nRoi/ns													;es la posicon en coord y de los puntos del roi del crater
		crater_x=nRoi-crater_y*ns											;es la posicon en coord x de los puntos del roi del crater
		crater_data_dem=envi_get_roi_data(roi_id[0],fid=fid_dem,pos=0) 		;contiene los valores de elevacion del dem de la zona que abarca el roi del crater
		crater_data_slope=envi_get_roi_data(roi_id[0],fid=fid_slope,pos=0) 	;contiene los valores de pendiente de la zona que abarca el roi del crater
		envi_delete_rois, roi_id

		;clculo de valores min y max de las coord x-y del contorno[i] del crater dentro del DEM
		crater_x_min = MIN(crater_x)
		crater_x_max = MAX(crater_x)
		crater_y_min = MIN(crater_y)
		crater_y_max = MAX(crater_y)

		;clculo del num de columnas y filas que abarcan el contorno[i] del crater
		crater_col = crater_x_max - crater_x_min+1
		crater_row = crater_y_max - crater_y_min+1

		;construccion del DEM del crater; dem va a tener zeros alrededor del contorno[i]
		;--------------------------
		;OPCION DEM INTEGER O FLOAT
		if (dem_type eq 2) then begin
			crater_xyz=intarr(3,N_ELEMENTS(crater_data_dem))
			crater_dem=intarr(crater_col,crater_row)
			crater_dembig=intarr(col,row)
			cratermask=intarr(col,row)
		endif
		if (dem_type eq 4) then begin
			crater_xyz=fltarr(3,N_ELEMENTS(crater_data_dem))
			crater_dem=fltarr(crater_col,crater_row)
			crater_dembig=fltarr(col,row)
			cratermask=fltarr(col,row)
		endif
		;---------------------------
		crater_xyz[0,*] = crater_x - crater_x_min
		crater_xyz[1,*] = crater_y - crater_y_min
		crater_xyz[2,*] = crater_data_dem

		;------------------------------------------------------------------
		;AGREGADO MAYO 2010 para volcs con alturas negativas (eg en Etiopia)
		crater_dem[*,*]=-3333
		;------------------------------------------------------------------
		for k=0L,N_ELEMENTS(crater_data_dem)-1 do begin
			crater_dem[crater_xyz[0,k],crater_xyz[1,k]] = crater_xyz[2,k]
		endfor

		;construccion del SLOPE del crater
		crater_ijk=fltarr(3,N_ELEMENTS(crater_data_slope))
		crater_ijk[0,*]=crater_x - crater_x_min
		crater_ijk[1,*]=crater_y - crater_y_min
		crater_ijk[2,*]=crater_data_slope
		crater_slope=fltarr(crater_col,crater_row)
		for k=0L,N_ELEMENTS(crater_data_slope)-1 do begin
			crater_slope[crater_ijk[0,k],crater_ijk[1,k]] = crater_ijk[2,k]
		endfor

		;creacin de img del tamanio del dem pero solo con los datos del crater y ceros alrededor, para usar como mascara
		cratermask_difx = crater_x_min - x_min
		cratermask_dify = crater_y_min - y_min
		cratermask_xyz=crater_xyz
		cratermask_xyz[0,*] = cratermask_xyz[0,*] + cratermask_difx
		cratermask_xyz[1,*] = cratermask_xyz[1,*] + cratermask_dify
		;-------------------------------------------------------------------
		;AGREGADO MAYO 2010 para volcs con alturas negativas (eg en Etiopia)
		crater_dembig[*,*]=-6666
		;-------------------------------------------------------------------
		for k=0L,N_ELEMENTS(crater_data_dem)-1 do begin
			crater_dembig[cratermask_xyz[0,k],cratermask_xyz[1,k]] = cratermask_xyz[2,k]
		endfor

		;mascara tamao del dem con 1 donde esta el crater y 0 fuera del crater
	   	cratermask[*,*]=0
		cratermask[WHERE(crater_dembig gt MIN(crater_dembig))]=1
		;-----------------------------------------------
	endif

	;------------------------------------------------
	;llamado al programa MORVOLC y envio de variables
	;------------------------------------------------
	morvolc_v1, paramFile, dem, dem_tot, slope, slope_tot, hillshade, hillshade_tot, $
			 	px_dimx, px_dimy, coord_utm, x_start_utm, y_start_utm, listaRoi[i], $
			 	crater_dem, crater_slope, crater_dembig, cratermask, cratermask_difx, cratermask_dify
	;------------------------------------------------

	ENDFOR
	;------------------------------------

;fin de IF de precaucin
endif

return

end

